/*
    ADVVXe

    2002/ 5/ 2 ˁ@P
*/

#include <windows.h>
#include <mmsystem.h>
#include "classes.h"

#pragma comment(lib,"winmm.lib")

#define IDM_EXIT 1

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
bool loadColorTable(LPCTSTR,LPBYTE);
bool loadPixels(LPCTSTR,LPBYTE);

HINSTANCE hInst;
HWND hwMain;
HMENU hMenu,hMenuFile;
CGame *game;
DWORD dwTime;

RECT recGame={2,2,546,546};

DWORD getTime() {

	DWORD dwTmp;

	timeBeginPeriod(1);
	dwTmp=timeGetTime();
	timeEndPeriod(1);

	return dwTmp;

}

int WINAPI WinMain (HINSTANCE hInstance,HINSTANCE hPrevInstance,
                    PSTR szCmdLine,int iCmdShow){

	MSG  msg;
	WNDCLASS wndclass;

	hInst=hInstance; /* vZX̃nhۑ */

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL,IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";

	RegisterClass(&wndclass);

	hwMain=CreateWindow("CWindow","ADV",WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU,
             CW_USEDEFAULT,CW_USEDEFAULT,580,580,NULL,NULL,hInstance,NULL);

	/* j[쐬 */
	hMenu=CreateMenu();
	hMenuFile=CreateMenu();
	AppendMenu(hMenuFile,MF_STRING,IDM_EXIT,"I(&Xj");
	AppendMenu(hMenu,MF_POPUP,(UINT)hMenuFile,"t@Ci&Fj");

	/* EChEɃj[ݒ */
	SetMenu(hwMain,hMenu);

	ShowWindow(hwMain,iCmdShow); /* EChE\ */
	UpdateWindow(hwMain);        /* ĕ` */

	dwTime=getTime();

	while (1) { /* C[v */

		if (PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) {

			if (!GetMessage (&msg,NULL,0,0)) /* bZ[W */
				return msg.wParam ;

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		} else if (getTime()>dwTime+16) {

			dwTime=getTime();

			if (GetForegroundWindow()==hwMain) { /* L[͊Ď */

				if (GetAsyncKeyState(VK_UP)<0)
					game->OnVK_UP();

				if (GetAsyncKeyState(VK_RIGHT)<0)
					game->OnVK_RIGHT();

				if (GetAsyncKeyState(VK_DOWN)<0)
					game->OnVK_DOWN();

				if (GetAsyncKeyState(VK_LEFT)<0)
					game->OnVK_LEFT();

			}

			if (game->action()) { /* Q[i߂ */
	
				InvalidateRect(hwMain,&recGame,FALSE);
				UpdateWindow(hwMain);

			}

		} else
			Sleep(0);

	}

}

LRESULT CALLBACK WndProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	LPBYTE lpWrk,lpTmp;
	int i,j,w,h;
	RECT rec;

	switch (iMsg) {

	case WM_CREATE:

		game=new CGame();

		lpWrk=(LPBYTE)GlobalAlloc(GPTR,256*256);

		for (i=10;i<246;i++) /* Ń}bv쐬 */
			for (j=10;j<246;j++)
				lpWrk[j+i*256]=8+rand() % 4;

		game->setMap(lpWrk);

		loadColorTable("chr.bmp",lpWrk);
		game->setColorTable(lpWrk);

		loadPixels("chr.bmp",lpWrk);

		lpTmp=(LPBYTE)GlobalAlloc(GPTR,1024);

		for (i=0;i<32;i++) /* Lp^[O쐬 */
			CopyMemory(lpTmp+i*32,lpWrk+i*256,32);

		game->setPlayerBMP(lpTmp,0);

		for (i=0;i<32;i++) /* Lp^[P쐬 */
			CopyMemory(lpTmp+i*32,lpWrk+i*256+32,32);

		game->setPlayerBMP(lpTmp,1);

		GlobalFree(lpTmp);

		/* }bv`bvݒ */
		loadPixels("parts.bmp",lpWrk);
		game->setMapChips(lpWrk);

		/* Q[ */
		game->setPlayerPos(12,12);
		game->init(GetDC(hwnd));

		GlobalFree(lpWrk);

		/* EChETCY */
		rec.left=0;
		rec.top=0;
		rec.right=548;
		rec.bottom=548;
		AdjustWindowRect(&rec,WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU,TRUE);
		w=rec.right-rec.left;
		h=rec.bottom-rec.top;
		SetWindowPos(hwnd,HWND_TOP,0,0,w,h,SWP_NOMOVE);

		return 0;

	case WM_COMMAND:

		switch(LOWORD(wParam)) {

		case IDM_EXIT:

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);

		game->draw(hdc,2,2);

		EndPaint(hwnd,&ps);

		return 0;

	case WM_DESTROY :

		delete game;

		PostQuitMessage(0);
		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool loadColorTable(LPCTSTR lpszFn,LPBYTE lpColors) { /* J[e[uǂݍ */

	DWORD dummy;
	LPBYTE lpBuf;
	HANDLE fh;

	fh=CreateFile(lpszFn,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL); /* t@CI[v */

	lpBuf=(LPBYTE)GlobalAlloc
	    (GPTR,GetFileSize(fh,NULL)); /* obt@m */

	ReadFile(fh,lpBuf,GetFileSize(fh,NULL),&dummy,NULL);

	CloseHandle(fh);

	CopyMemory(lpColors,lpBuf+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER),1024);

	GlobalFree(lpBuf);

	return true;

}

bool loadPixels(LPCTSTR lpszFn,LPBYTE lpArg) { /* sNZǂݍ */

	DWORD offset,dummy;
	LPBYTE lpBuf;
	LPBITMAPINFO lpWrkBM;
	HANDLE fh;
	int i;

	fh=CreateFile(lpszFn,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL); /* t@CI[v */

	lpBuf=(LPBYTE)GlobalAlloc
	    (GPTR,GetFileSize(fh,NULL)); /* obt@m */

	ReadFile(fh,lpBuf,GetFileSize(fh,NULL),&dummy,NULL);

	CloseHandle(fh);

	lpWrkBM=(LPBITMAPINFO)(lpBuf+sizeof(BITMAPFILEHEADER));

	offset=*(LPDWORD)(lpBuf+10);

	for (i=0;i<256;i++)
		CopyMemory(lpArg+(255-i)*256,lpBuf+offset+i*256,256);

	GlobalFree(lpBuf);

	return true;

}
