#include "classes.h"

CMap::CMap() {

	lpBuf=(LPBYTE)GlobalAlloc(GPTR,256*256+32*32*8*8);

	lpMap=lpBuf;

	for (int i=0;i<64;i++)
		lpChips[i]=lpBuf+256*256+i*32*32;

}

bool CMap::setMap(LPBYTE lpArg) {

	CopyMemory(lpMap,lpArg,256*256);

	return true;

}

bool CMap::setChips(LPBYTE lpArg) {

	if (lpArg==NULL)
		return false;

	for (int i=0;i<8;i++)
		for (int j=0;j<8;j++)
			for (int k=0;k<32;k++)
				CopyMemory(lpBuf+256*256+(j+i*8)*1024+k*32,lpArg+j*32+(i*32+k)*256,32);

	return true;

}

int CMap::getChip(int iArg1,int iArg2) { return lpMap[iArg1+iArg2*256]; }

bool CMap::enter(int iArg1,int iArg2) {

	return lpMap[iArg1+iArg2*256]!=0;

}

bool CMap::draw(LPBYTE lpArg,int iArg1,int iArg2,int iArg3,int iArg4) {

	if (iArg1<0 ||iArg1>255 ||iArg2<0 ||iArg2>255 ||
	    iArg3<1 ||iArg1+iArg3>255 ||iArg4<1 ||iArg2+iArg4>255)
		return false;

	int i,j,k;
	LPBYTE lpBMP;

	for (i=0;i<iArg4;i++)
		for (j=0;j<iArg3;j++) {

			lpBMP=lpChips[lpMap[j+iArg1+(i+iArg2)*256]];

			for (k=0;k<32;k++)
				CopyMemory(lpArg+j*32+(i*32+k)*iArg3*32,lpBMP+k*32,32);

		}

	return true;
	
}

CMap::~CMap() {

	GlobalFree(lpBuf);

}
